#ifndef _MSC_H_
#define _MSC_H_

#include "../coding/energy_dispersal.h"
#include "fig.h"
#include "../audio/super_frame.h"

typedef struct {
  int configured;
  int start;
  int l[4];
  int pi[4];
  int bitrate;      /* unit kbps */
} sub_channel;

typedef struct {
  int cif_id;
  int in[16][55296];
  int in_start_cif_id;
  int in_start;
  int in_size;            /* if < 16 then in is not full yet */
  sub_channel sc[64];
  energy_dispersal *energy_dispersal;
  super_frame *audio;
  void (*send_audio)(void *, void *, int);
  void *send_audio_data;
} msc_config;

msc_config *new_msc_config(void (*send_audio)(void *, void *, int),
                           void *send_audio_data);

void receive_msc_bits(msc_config *m, int cif_id, int *bits, int cif_symbol);

void msc_update_config(msc_config *c, frame_figs *f);

#endif /* _MSC_H_ */
